import java.io.File;

import ClearImageJNI.*;


public class TestIO {
	

	
	/*
	protected static boolean openFromFile(ICiImage Image, String filename) throws Exception // ezjcom.JComException
	{
		try{
		Image.Open(filename, 1);
		} catch (Exception ex) {;}
		boolean ret = Image.getIsValid() == EBoolean.ciTrue;
		if (ret)
			System.out.println("  Opened: " + filename);
		return ret;
	}
	*/
	
	 protected static void _save (ICiImage Image, String fileName, String ext, String op,  boolean append)  throws Exception // ezjcom.JComException
	 {
		 String path;
		 if (fileName.length() == 0)
			 fileName = "$testOut";
		 if (ext.length() == 0)
			 ext = "bmp"; // COM
		 if (append  && (ext == "pdf"  || ext == "tif"))
			{
			 path = fileName + "." + ext;
			 Image.Append(path, EFileFormat.ciEXT);
			}
		 else
			 {
			 path = fileName  + (op.length() == 0 ? "" : "." + op) + ".bmp";
			 Image.SaveAs(path, EFileFormat.ciEXT);
		 	}
	 }
	 
	 private static boolean FileExists (String fileName) {
		    File f = new File(fileName);
		    boolean exists = f.exists();
		    return exists;
		  }
	 

	 
	 private static boolean OpenImage(ICiImage Image, String fileName)
	 {
	 	boolean ret = false;
	 	if (!FileExists(fileName))
	 				return false;
	 	try
	 	{

	 		System.out.println("..... Opening from: "  + fileName);
 			Image.Open(fileName, 1);
	 		
	 		if (false) { // testing
	 		  	System.out.println("OPPENED: w: " + Image.getWidth() + "   h: " + Image.getHeight() + "   bpp: "+ Image.getBitsPerPixel() +
		 		  	  	 "   hdpi: " + Image.getHorzDpi() +  "   vdpi: " + Image.getVertDpi() + 
		 		  	  	 "   file: " + Image.getFileName());
	 		  	Image.SaveAs("$testOpenned.bmp", EFileFormat.ciEXT);
	 			Image.CopyToClipboard();
	 			}
	 		ret = true;

	 	}
	 	catch (Exception ex)
	 	{
	 		TestCiApi.dump_error(ex);
	 		return false;
	 	}
	 	return ret;
	 }

	 private static boolean OpenFromFilePath(ICiImage Image, String path, String filename)
	 {
	 	String fnExt = path;
	   fnExt += filename;
	 	return OpenImage(Image, fnExt);
	 }

	 private static String[] validExt = new String[] {"tif","tiff", "pdf", "jpg", "jpeg", "png", "gif", "bmp"};
	 
	 private static String getExt(String filename, String[] exts)
	 {
		 for (String ext : exts)
		 {
			 if (filename.length() > (ext.length() + 2))
			 {
				 if (!TestUtil.stricmp(filename.substring(filename.length()-ext.length() - 1).toLowerCase(), "." + ext))
				   return ext;
			 }
		 }
		 return "";
	 }
	 
	 protected static boolean OpenFromFile(ICiImage Image, String filename)
	 {
	 			if (OpenImage(Image, filename)) // try to appen ".bmp" to file name
	 				return true;
	 			String fileNameExt =  filename;
	 			
	 			 // attach .bmp  extension if not  present
	 			if (getExt(fileNameExt, validExt).length() == 0)
		 				 fileNameExt += ".bmp";
	 			
	 			if (OpenFromFilePath(Image, (""), fileNameExt))
	 				return true;
	 			if (OpenFromFilePath(Image, ("./Images/"), fileNameExt))
	 				return true;
	 			if (OpenFromFilePath(Image, ("../Images/"), fileNameExt))
	 				return true;
	 			if (OpenFromFilePath(Image, ("../../Images/"), fileNameExt))
	 				return true;
	 			if (OpenFromFilePath(Image, ("../../../Images/"), fileNameExt))
	 				return true;
	 			if (OpenFromFilePath(Image, ("../../../bin/Images/"), fileNameExt))
	 				return true;

	 			return false;
	 }

	 //===============================================================


	 protected static void saveImage(ICiImage Image, String fileName)
	 {
	 	try
	 	{
	 		System.out.println("..... Saving to : " + fileName);

	 		 Image.SaveAs(fileName, EFileFormat.ciEXT);
	 	}
	 	catch (Exception ex)
	 	{
	 		TestCiApi.dump_error(ex);
	 	}
	 }
}
